// /////////////////////////////////////////////////////////////////////////
// C++ code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#include "../inc/memory_inst.hpp"



memory_inst::memory_inst() :
    prdata_old(0UL),
    pready_old(false),
    oeb_old(false),
    we_n_old(false),
    sync_old(false),
    vpab_old(false),
    datao_old(uint8_t(0U)),
    addr_old(uint16_t(0U)),
    rst_old(false),
    clk_old(false),
    hif_a2t_data(
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr),
    pwdata_var(0UL),
    paddr_var(0UL),
    state(uint8_t(0U)),
    state_sig_var(uint8_t(0U)),
    _ram(),
    _rom(),
    ram_addr(uint16_t(0U)),
    rom_addr(uint16_t(0U)),
    addr_firstbit_ram(false),
    addr_firstbit_rom(false),
    state_new(uint8_t(0U)),
    process_in_queue(false),
    flag_initial_process_executed(false),
    flag_state(false),
    flag_clk(false),
    flag_addr(false),
    flag_process_0_process_2_executed(false),
    flag_pos_clk(false)
{
    for (int ind_1 = 32767L; ind_1 >= 0L; ind_1 = ind_1 - 1)
    {
        _ram[ind_1] = uint8_t(0U);
    }
    for (int ind_2 = 16383L; ind_2 >= 0L; ind_2 = ind_2 - 1)
    {
        _rom[ind_2] = uint8_t(0U);
    }
}


memory_inst::~memory_inst()
{}


void memory_inst::initial_process()
{
    state_sig_var = uint8_t(0U);
    state_new = state_sig_var & uint8_t(15U);
    *hif_a2t_data.datai = uint8_t(0U);
    *hif_a2t_data.irq_n = false;
    *hif_a2t_data.nmi_n = false;
    *hif_a2t_data.res_n = false;
    *hif_a2t_data.rdy = false;
    *hif_a2t_data.sob_n = false;
    *hif_a2t_data.psel1 = false;
    *hif_a2t_data.psel2 = false;
    *hif_a2t_data.psel3 = false;
    *hif_a2t_data.psel4 = false;
    *hif_a2t_data.psel5 = false;
    *hif_a2t_data.psel6 = false;
    *hif_a2t_data.psel7 = false;
    *hif_a2t_data.psel8 = false;
    *hif_a2t_data.penable = false;
    *hif_a2t_data.presetn = false;
    *hif_a2t_data.pwrite = false;
    *hif_a2t_data.paddr = 0UL;
    *hif_a2t_data.pwdata = 0UL;
}


void memory_inst::process()
{
    switch (state_sig_var)
    {
        case uint8_t(0U):
            *hif_a2t_data.rdy = false;
            *hif_a2t_data.sob_n = false;
            *hif_a2t_data.irq_n = false;
            *hif_a2t_data.nmi_n = false;
            *hif_a2t_data.res_n = false;
            break;
        case uint8_t(1U):
        case uint8_t(2U):
        case uint8_t(6U):
            *hif_a2t_data.rdy = true;
            *hif_a2t_data.sob_n = true;
            *hif_a2t_data.irq_n = false;
            *hif_a2t_data.nmi_n = false;
            *hif_a2t_data.res_n = false;
            break;
        case uint8_t(3U):
        case uint8_t(4U):
        case uint8_t(5U):
            *hif_a2t_data.rdy = true;
            *hif_a2t_data.sob_n = true;
            *hif_a2t_data.irq_n = false;
            *hif_a2t_data.nmi_n = true;
            *hif_a2t_data.res_n = false;
            break;
        case uint8_t(7U):
        case uint8_t(8U):
        case uint8_t(9U):
            *hif_a2t_data.rdy = true;
            *hif_a2t_data.sob_n = true;
            *hif_a2t_data.irq_n = false;
            *hif_a2t_data.nmi_n = false;
            *hif_a2t_data.res_n = true;
            break;
        default:
            break;
    }
}


void memory_inst::process_1()
{
    ram_addr = *hif_a2t_data.addr & uint16_t(16383U);
    rom_addr = *hif_a2t_data.addr & uint16_t(16383U);
    addr_firstbit_ram = static_cast< uint16_t >( *hif_a2t_data.addr >> uint16_t
        (15U) ) & uint16_t(1U);
    addr_firstbit_rom = static_cast< uint16_t >( *hif_a2t_data.addr >> uint16_t
        (15U) ) & uint16_t(1U);
    if (!addr_firstbit_ram && !(*hif_a2t_data.we_n))
    {
        _ram[static_cast< int32_t >( ram_addr )] = *hif_a2t_data.datao;
    }
    else if (!addr_firstbit_ram && *hif_a2t_data.we_n)
    {
        *hif_a2t_data.datai = _ram[static_cast< int32_t >( ram_addr )];
    }
    else if (addr_firstbit_rom && *hif_a2t_data.we_n)
    {
        *hif_a2t_data.datai = _rom[static_cast< int32_t >( rom_addr )];
    }
}


void memory_inst::process_0_process_2()
{
    if (*hif_a2t_data.rst == true)
    {
        state_sig_var = uint8_t(0U);
        state_new = state_sig_var & uint8_t(15U);
    }
    else
    {
        switch (state_sig_var)
        {
            case uint8_t(0U):
                state_sig_var = uint8_t(1U);
                state_new = state_sig_var & uint8_t(15U);
                break;
            case uint8_t(1U):
                state_sig_var = uint8_t(2U);
                state_new = state_sig_var & uint8_t(15U);
                break;
            case uint8_t(2U):
                state_sig_var = uint8_t(3U);
                state_new = state_sig_var & uint8_t(15U);
                break;
            case uint8_t(3U):
                state_sig_var = uint8_t(4U);
                state_new = state_sig_var & uint8_t(15U);
                break;
            case uint8_t(4U):
                state_sig_var = uint8_t(5U);
                state_new = state_sig_var & uint8_t(15U);
                break;
            case uint8_t(5U):
                state_sig_var = uint8_t(6U);
                state_new = state_sig_var & uint8_t(15U);
                break;
            case uint8_t(6U):
                state_sig_var = uint8_t(7U);
                state_new = state_sig_var & uint8_t(15U);
                break;
            case uint8_t(7U):
            case uint8_t(9U):
                state_sig_var = uint8_t(8U);
                state_new = state_sig_var & uint8_t(15U);
                break;
            case uint8_t(8U):
                state_sig_var = uint8_t(9U);
                state_new = state_sig_var & uint8_t(15U);
                break;
            default:
                break;
        }
    }
    pwdata_var = *hif_a2t_data.pwdata;
    paddr_var = *hif_a2t_data.paddr;
    *hif_a2t_data.psel1 = _ram[7199L] & uint8_t(1U);
    *hif_a2t_data.psel2 = static_cast< uint8_t >( _ram[7199L] >> uint8_t(1U) ) &
         uint8_t(1U);
    *hif_a2t_data.psel3 = static_cast< uint8_t >( _ram[7199L] >> uint8_t(2U) ) &
         uint8_t(1U);
    *hif_a2t_data.psel4 = static_cast< uint8_t >( _ram[7199L] >> uint8_t(3U) ) &
         uint8_t(1U);
    *hif_a2t_data.psel5 = static_cast< uint8_t >( _ram[7199L] >> uint8_t(4U) ) &
         uint8_t(1U);
    *hif_a2t_data.psel6 = static_cast< uint8_t >( _ram[7199L] >> uint8_t(5U) ) &
         uint8_t(1U);
    *hif_a2t_data.psel7 = static_cast< uint8_t >( _ram[7199L] >> uint8_t(6U) ) &
         uint8_t(1U);
    *hif_a2t_data.psel8 = static_cast< uint8_t >( _ram[7199L] >> uint8_t(7U) ) &
         uint8_t(1U);
    *hif_a2t_data.penable = _ram[7208L] & uint8_t(1U);
    *hif_a2t_data.presetn = static_cast< uint8_t >( _ram[7208L] >> uint8_t(1U) 
        ) & uint8_t(1U);
    *hif_a2t_data.pwrite = static_cast< uint8_t >( _ram[7208L] >> uint8_t(2U) )
         & uint8_t(1U);
    pwdata_var = pwdata_var & 16777215UL | static_cast< uint32_t >( _ram[7203L]
         ) << 24L;
    pwdata_var = pwdata_var & 4278255615UL | static_cast< uint32_t >( _ram[7202L
        ] ) << 16L;
    pwdata_var = pwdata_var & 4294902015UL | static_cast< uint32_t >( _ram[7201L
        ] ) << 8L;
    pwdata_var = pwdata_var & 4294967040UL | _ram[7200L];
    paddr_var = paddr_var & 16777215UL | static_cast< uint32_t >( _ram[7198L] )
         << 24L;
    paddr_var = paddr_var & 4278255615UL | static_cast< uint32_t >( _ram[7197L]
         ) << 16L;
    paddr_var = paddr_var & 4294902015UL | static_cast< uint32_t >( _ram[7196L]
         ) << 8L;
    paddr_var = paddr_var & 4294967040UL | _ram[7195L];
    _ram[7207L] = *hif_a2t_data.prdata >> 24L & 255UL;
    _ram[7206L] = *hif_a2t_data.prdata >> 16L & 255UL;
    _ram[7205L] = *hif_a2t_data.prdata >> 8L & 255UL;
    _ram[7204L] = *hif_a2t_data.prdata;
    _ram[7208L] = *hif_a2t_data.pready ? static_cast< uint8_t >( _ram[7208L] | uint8_t
        (8U) ) : static_cast< uint8_t >( _ram[7208L] & uint8_t(247U) );
    *hif_a2t_data.paddr = paddr_var;
    *hif_a2t_data.pwdata = pwdata_var;
}


void memory_inst::update_input_queue( bool synch_phase )
{
    process_in_queue = false;
    if (*hif_a2t_data.clk != clk_old)
    {
        clk_old = *hif_a2t_data.clk;
        flag_clk = true;
        if (*hif_a2t_data.clk == true)
        {
            flag_pos_clk = true;
        }
        else
        {
            flag_pos_clk = false;
        }
        process_in_queue = true;
    }
    else
    {
        flag_clk = false;
        flag_pos_clk = false;
    }
    rst_old = *hif_a2t_data.rst;
    if (*hif_a2t_data.addr != addr_old)
    {
        addr_old = *hif_a2t_data.addr;
        flag_addr = true;
        process_in_queue = true;
    }
    else
    {
        flag_addr = false;
    }
    datao_old = *hif_a2t_data.datao;
    vpab_old = *hif_a2t_data.vpab;
    sync_old = *hif_a2t_data.sync;
    we_n_old = *hif_a2t_data.we_n;
    oeb_old = *hif_a2t_data.oeb;
    pready_old = *hif_a2t_data.pready;
    prdata_old = *hif_a2t_data.prdata;
}


void memory_inst::update_event_queue()
{
    process_in_queue = false;
    update_input_queue( false );
    if (state != state_new)
    {
        state = state_new;
        flag_state = true;
        process_in_queue = true;
    }
    else
    {
        flag_state = false;
    }
}


void memory_inst::flag_elaboration()
{
    if (flag_state)
    {
        process();
    }
    if (flag_clk || flag_addr)
    {
        process_1();
    }
    flag_process_0_process_2_executed = false;
    if (flag_pos_clk)
    {
        process_0_process_2();
        flag_process_0_process_2_executed = true;
    }
}


void memory_inst::start_of_simulation()
{
    initial_process();
    flag_initial_process_executed = true;
    process();
    process_1();
    process_0_process_2();
    flag_process_0_process_2_executed = true;
}


void memory_inst::initialize()
{
    start_of_simulation();
}




